#ifndef OPTION_H

/*!
  \file
  \brief オプション用のコンポーネント

  \author Satofumi KAMIMURA

  $Id$
*/

#include "Component.h"
#include <memory>

namespace qrk
{
    class Menu;
    class Label;
}


class Option : public qrk::Component
{
public:
    explicit Option(const qrk::Rect<long>& rect);
    ~Option(void);

    qrk::Rect<long> rect(void) const;
    void setEventAcceptable(bool acceptable);
    void setAlpha(float alpha);
    float alpha(void);
    void setRotateAngle(const qrk::Angle& angle);
    void draw(const qrk::Rect<long>& area);

    void addSubMenu(qrk::Menu* sub_menu, const qrk::Point<long>& position,
                    qrk::Label* cursor_label,
                    const qrk::Point<long>& cursor_offset,
                    bool draw_front = true);

private:
    Option(const Option& rhs);
    Option& operator = (Option& rhs);

    struct pImpl;
    std::auto_ptr<pImpl> pimpl;
};

#endif /* !OPTION_H */
