-- 決まり字のグループ管理
--
-- $Id: kimariji_group.lua,v 43a696b157fd 2010/05/16 02:23:01 Satofumi $

_G.kimariji_title_ = {}
_G.kimariji_group_ = {}

local group_index_ = 0
local group_id_max_ = 1


-- １枚札
group_index_ = group_index_ + 1
kimariji_title_[group_index_] = "１枚札: む・す・め・ふ・さ・ほ・せ"
kimariji_group_[group_index_] = {
   { { 87, 1 } }, -- む
   { { 18, 1 } }, -- す
   { { 57, 1 } }, -- め
   { { 22, 1 } }, -- ふ
   { { 70, 1 } }, -- さ
   { { 81, 1 } }, -- ほ
   { { 77, 1 } }, -- せ
}


-- ２枚札
group_index_ = group_index_ + 1
kimariji_title_[group_index_] = "２枚札: う・つ・し・も・ゆ"
kimariji_group_[group_index_] = {
   { { 65, 2 }, { 74, 2 } }, -- う
   { { 13, 2 }, { 23, 2 } }, -- つ
   { { 37, 2 }, { 40, 2 } }, -- し
   { { 66, 2 }, { 100, 2 } }, -- も
   { { 46, 2 }, { 71, 2 } }, -- ゆ
}


-- ３枚札
group_index_ = group_index_ + 1
kimariji_title_[group_index_] = "３枚札: い・ち"
kimariji_group_[group_index_] = {
   { { 61, 2 }, { 21, 3 }, { 63, 3 } }, -- い
   { { 17, 2 }, { 42, 4 }, { 75, 4 } }, -- ち
}

group_index_ = group_index_ + 1
kimariji_title_[group_index_] = "３枚札: ひ・き"
kimariji_group_[group_index_] = {
   { { 33, 2 }, { 35, 3 }, { 99, 3 } }, -- ひ
   { { 91, 2 }, { 15, 6 }, { 50, 6 } }, -- き
}


-- ４枚札
group_index_ = group_index_ + 1
kimariji_title_[group_index_] = "４枚札: は・や"
kimariji_group_[group_index_] = {
   { { 2, 3 }, { 67, 3 }, { 9, 3 }, { 96, 3 } }, -- は
   { { 47, 2 }, { 59, 2 }, { 28, 3 }, { 32, 3 } }, -- や
}

group_index_ = group_index_ + 1
kimariji_title_[group_index_] = "４枚札: よ・か"
kimariji_group_[group_index_] = {
   { { 62, 2 }, { 85, 2 }, { 83, 5 }, { 93, 5 } }, -- よ
   { { 6, 2 }, { 51, 2 }, { 48, 3 }, { 98, 3 } }, -- か
}


-- ５枚以上
group_index_ = group_index_ + 1
kimariji_title_[group_index_] = "５枚札: み"
kimariji_group_[group_index_] = {
   { { 14, 2 }, { 90, 2 }, { 94, 2 }, { 49, 3 }, { 27, 3 } },
}


-- た(６枚)
group_index_ = group_index_ + 1
kimariji_title_[group_index_] = "６枚札: た"
kimariji_group_[group_index_] = {
   { { 73, 2 }, { 55, 2 }, { 4, 2 }, { 89, 2 }, { 16, 2 },
     { 34, 2 } },
}


-- こ(６枚)
group_index_ = group_index_ + 1
kimariji_title_[group_index_] = "６枚札: こ"
kimariji_group_[group_index_] = {
   { { 10, 2 }, { 41, 2 }, { 24, 2 }, { 97, 2 }, { 29, 4 },
     { 68, 4 } },
}


-- わ(７枚)
group_index_ = group_index_ + 1
kimariji_title_[group_index_] = "７枚札: わ"
kimariji_group_[group_index_] = {
   { { 20, 2 }, { 8, 3 }, { 92, 3 }, { 38, 3 }, { 54, 3 },
     { 11, 6 }, { 76, 6 } },
}


-- お(７枚)
group_index_ = group_index_ + 1
kimariji_title_[group_index_] = "７枚札: お"
kimariji_group_[group_index_] = {
   { { 72, 2 }, { 82, 2 }, { 5, 2 }, { 26, 2 }, { 60, 3 },
     { 44, 3 }, { 95, 3 } }
}


-- な(８枚)
group_index_ = group_index_ + 1
kimariji_title_[group_index_] = "８枚札: な"
kimariji_group_[group_index_] = {
   { { 36, 2 }, { 80, 3 }, { 84, 3 }, { 53, 3 }, { 86, 3 },
     { 25, 3 }, { 19, 4 }, { 88, 4 } },
}


-- あ(１６枚)
group_index_ = group_index_ + 1
kimariji_title_[group_index_] = "1６枚札: あ"
kimariji_group_[group_index_] = {
   { { 45, 3 }, { 78, 3 }, { 56, 3 }, { 69, 3 }, { 1, 3 },
     { 79, 3 }, { 7, 3 }, { 12, 3 }, { 30, 3 }, { 58, 3 },
     { 39, 3 }, { 31, 6 }, { 64, 6 }, { 3, 2 }, { 43, 2 },
     { 52, 2 } },
}


group_id_max_ = group_index_


for group = 1, #kimariji_group_ do
   for i = 1, #kimariji_group_[group] do
      for j = 1, #kimariji_group_[group][i] do
         waka_kimariji_size_[kimariji_group_[group][i][j][1]] =
            kimariji_group_[group][i][j][2]
      end
   end
end


-- グループ数
function kimariji_group_id_max()
   return group_id_max_
end

group_index_ = 0
