-- メニューの作成補助
-- Satofumi KAMIMURA
-- $Id: menu_utils.lua,v dfd459a213c3 2010/05/06 16:39:10 Satofumi $


function createMenu(menu, buttons_text, base_rect,
                    font, surfaces, buttons, align)

   local normal_base_color = Color(1.0, 1.0, 1.0, 0.35)
   local normal_base_surface = ColorSurface(base_rect, normal_base_color)
   table.insert(surfaces, normal_base_surface)

   local focused_base_color = Color(0.7, 0.7, 1.0, 0.5)
   local focused_base_surface = ColorSurface(base_rect, focused_base_color)
   table.insert(surfaces, focused_base_surface)

   local pressed_base_color = Color(0.5, 0.5, 1.0, 0.8)
   local pressed_base_surface = ColorSurface(base_rect, pressed_base_color)
   table.insert(surfaces, pressed_base_surface)

   for i = 1, #buttons_text do
      local text_surface = TextSurface(font, buttons_text[i])
      local normal_surface = MultiSurface(normal_base_surface)

      local x
      if align == "left" then
         x = 0
      else
         -- "center"
         x = center(text_surface, base_rect.w / 2)
      end

      local surface_offset = Point(x, middle(text_surface, base_rect.h / 2))
      normal_surface:push_front(text_surface, surface_offset)

      local focused_surface = MultiSurface(focused_base_surface)
      focused_surface:push_front(text_surface, surface_offset)

      local pressed_surface = MultiSurface(pressed_base_surface)
      pressed_surface:push_front(text_surface, surface_offset)

      local button = Button(normal_surface, focused_surface, pressed_surface)
      menu:addButton(button, i);

      table.insert(surfaces, pressed_surface)
      table.insert(surfaces, focused_surface)
      table.insert(surfaces, normal_surface)
      table.insert(surfaces, text_surface)
      table.insert(buttons, button)
   end
   menu:setButtonStep(Point(0, base_rect.h + 8))
end
