-- タイピング練習
--
-- Satofumi KAMIMURA
-- $Id: practice_menu.lua,v 0f4334d7d817 2011/01/30 22:37:39 Satofumi $


-- state: タイピング練習
practice_menu = {}


local title_ = nil
local title_label_ = nil
local menu_ = nil
local surfaces_ = nil
local buttons_ = nil

local selected_index_ = -1


function practice_menu_set_waka()
   --waka_id_array_ = waka_handler_practice_waka(waka_id_size_)
   waka_id_array_ = { 1 }
end


function practice_menu_set_waka_weak()
   -- 入力開始が遅い順に和歌 ID を格納し、シャッフルする
   waka_id_array_ = waka_handler_shuffle(waka_handler_slow_waka(waka_id_size_))
end


function practice_menu_set_waka_kimariji()
   -- 決まり字毎に ID を格納し、シャッフルする
   waka_id_array_, group_id_ = waka_handler_kimariji_waka()
   --print(waka_id_array_, group_id_)
   --for i = 1, #waka_id_array_ do
   --print(waka_id_array_[i])
   --end
   --waka_id_array_ = { 1, 2 }
end


practice_menu["Enter"] =
   function(state)
      cleanupInput()

      -- タイトルの作成
      font_:setPixelSize(40)
      title_ = TextSurface(font_, "タイピング練習")
      title_label_ = Label(title_)
      title_label_:setPosition(Point(center(title_label_,
                                            screen_:rect().w / 2), title_y_))
      layer_:push_front(title_label_)

      -- メニュー項目の作成
      font_:setPixelSize(32)
      menu_ = Menu(screen_:rect(), Menu.Center, Menu.Verbatim)
      local buttons_text = {
         "下の句タイピング",
         "苦手な句の練習",
         "決まり字の練習",
         "戻る",
      }
      local base_rect = Rect(0, 0, 280, 42)
      require("menu_utils")
      buttons_ = {}
      surfaces_ = {}
      createMenu(menu_, buttons_text,
                 base_rect, font_, surfaces_, buttons_)
      menu_:setPosition(Point(center(menu_, screen_:rect().w / 2), menu_y_))
      layer_:push_front(menu_)
      if selected_index_ > 0 then
         menu_:setIndex(selected_index_ - 1)
      end
   end


practice_menu["Execute"] =
   function(state)
      -- 曲の再生を開始する
      if not back_music_:isPlaying() then
         back_music_:play(Music_menu_, 1000, BackMusic_Infinity, 1000)

         -- 前回タイピングの効果音が再生中ならば、再生を中止する
         sound_effect_epilogue_:stop()
      end

      redraw()
      expandMenu(menu_)

      -- メニューで選択された状態へ遷移させる
      if menu_:isClicked() then

         selected_index_ = menu_:clickedId()
         if selected_index_ == 1 then
            require("shimonoku_typing")
            require("display_subtitle")
            practice_menu_set_waka()
            display_subtitle_setText("下の句タイピング")
            display_subtitle_setText(#waka_id_array_ .. "首", 32)
            state:stateMachine():changeState(shimonoku_typing)

         elseif selected_index_ == 2 then
            require("shimonoku_typing")
            require("display_subtitle")
            practice_menu_set_waka_weak()
            display_subtitle_setText("苦手な句の練習")
            display_subtitle_setText(#waka_id_array_ .. "首", 32)
            state:stateMachine():changeState(shimonoku_typing)

         elseif selected_index_ == 3 then
            require("kimariji_typing")
            require("display_subtitle")
            practice_menu_set_waka_kimariji()
            display_subtitle_setText("決まり字の練習")
            display_subtitle_setText(kimariji_title_[group_id_], 32)
            state:stateMachine():changeState(kimariji_typing)

         elseif selected_index_ == 4 then
            sound_effect_input_terminated_:play(0.0, 0.0, 0.1)

            require("first_menu")
            state:stateMachine():changeState(first_menu)
            selected_index_ = 1
         end
      end

      if escape_event_:isActive() then
         require("first_menu")
         state:stateMachine():changeState(first_menu)
      end
   end


practice_menu["Exit"] =
   function(state)
      layer_:remove(menu_)
      layer_:remove(title_label_)

      title_label_ = nil
      title_ = nil
      buttons_ = nil
      surfaces_ = nil
      menu_ = nil

      collectgarbage("collect")
   end
