#ifndef HISTORY_GRAPH_H
#define HISTORY_GRAPH_H

/*!
  \file
  \brief タイピング履歴のグラフ表示

  \author Satofumi KAMIMURA

  $Id$
*/

#include "Component.h"
#include <memory>


namespace qrk
{
    class Color;
    class Font;
}


class HistoryGraph : public qrk::Component
{
public:
    explicit HistoryGraph(const qrk::Rect<long>& rect);
    ~HistoryGraph(void);

    qrk::Rect<long> rect(void) const;
    void setEventAcceptable(bool acceptable);
    void setAlpha(float alpha);
    float alpha(void);
    void setRotateAngle(const qrk::Angle& angle);
    void draw(const qrk::Rect<long>& area);

    void setFont(qrk::Font& font);
    void setBackgroundColor(const qrk::Color& color);

    void addData(float start_sec, float end_sec, float type_miss);
    void create(void);

private:
    HistoryGraph(const HistoryGraph& rhs);
    HistoryGraph& operator = (HistoryGraph& rhs);

    struct pImpl;
    std::auto_ptr<pImpl> pimpl;
};

#endif /* !HISTORY_GRAPH_H */
