/*!
  \file
  \brief Lua へのタイピング関連の関数を登録

  \author Satofumi KAMIMURA

  $Id: luabindTyping.cpp,v ea1a3e6caa29 2011/01/12 18:05:27 Satofumi $
*/

#include "luabindTyping.h"
#include "hyakutyping.h"
#include "HistoryGraph.h"
#include "Menu.h"
#include "Label.h"
#include "Option.h"
#include "Color.h"
#include "Font.h"
#include "LuaHandler.h"
#include <luabind/luabind.hpp>

using namespace qrk;
using namespace luabind;


void luabindTyping(lua_State* L)
{
    module(L)
        [
         def("version", (const char*(*)(void))&version),

         class_<HistoryGraph, qrk::Component>("HistoryGraph")
         .def(constructor<const qrk::Rect<long>&>())
         .def("setPosition", &HistoryGraph::setPosition)
         .def("position", &HistoryGraph::position)
         .def("rect", &HistoryGraph::rect)
         .def("setAlpha", &HistoryGraph::setAlpha)
         .def("setFont", &HistoryGraph::setFont)
         .def("setBackgroundColor", &HistoryGraph::setBackgroundColor)
         .def("addData", &HistoryGraph::addData)
         .def("create", &HistoryGraph::create),

         class_<Option, qrk::Component>("Option")
         .def(constructor<const qrk::Rect<long>&>())
         .def("setPosition", &Option::setPosition)
         .def("position", &Option::position)
         .def("rect", &Option::rect)
         .def("setAlpha", &Option::setAlpha)
         .def("addSubMenu", &Option::addSubMenu)
         ];
}
