-- サブタイトルの表示
--
-- Satofumi KAMIMURA
-- $Id$


-- state: サブタイトルの表示
display_subtitle = {}

local Initialized = 1

local subtitle_text_ = {}
local subtitle_ = {}
local subtitle_label_ = {}
local font_size_ = {}
local state_ = 0


function display_subtitle_clear()
   for i = 1, #subtitle_text_ do
      layer_:remove(subtitle_label_[i])
      subtitle_label_[i] = nil
      subtitle_[i] = nil
      subtitle_text_[i] = nil
   end

   subtitle_text_ = {}
   subtitle_label_ = {}
   subtitle_ = {}
   font_size_ = {}
   state_ = 0
end


function display_subtitle_setText(subtitle_text, font_size)

   if font_size == nil then
      font_size = 40
   end
   table.insert(font_size_, font_size)
   table.insert(subtitle_text_, subtitle_text)
end


display_subtitle["Enter"] =
   function(state)
      if state_ ~= Initialized then
         -- サブタイトルの作成
         for i = 1, #subtitle_text_ do
            font_:setPixelSize(font_size_[i])
            subtitle_[i] = TextSurface(font_, subtitle_text_[i])
            subtitle_label_[i] = Label(subtitle_[i])
            local position = Point(center(subtitle_label_[i],
                                          screen_:rect().w / 2), 120 + i * 64)
            subtitle_label_[i]:setPosition(position)
            layer_:push_front(subtitle_label_[i])
         end

         -- ENTER の入力待ちへ
         require("wait_enter")
         state:stateMachine():changeState(wait_enter)
         state_ = Initialized
      end
   end


display_subtitle["Execute"] =
   function(state)
      redraw()

      state:stateMachine():changePreviousState()
      display_subtitle_clear()
   end


display_subtitle["Exit"] =
   function(state)
   end
