-- 入力の処理
--
-- $Id$

require("waka_handler")


-- 入力文字列を変換して返す
function input_handler_convert(converted_text, input)

   converted_text = converted_text .. input
   converted_text = convertToJp(converted_text, is_roman_)
   local bs_pressed = false
   if bs_event_:isActive() then
      bs_pressed = true
      local utf8_text = Utf8(converted_text)
      utf8_text:pop_back()
      converted_text = utf8_text:toStdString()
   end
   local utf8_text = Utf8(converted_text)
   if utf8_text:size() > 10 then
      -- 文字数が長くなりすぎないようにする
      converted_text = utf8_text:substr(0, 10):toStdString()
   end

   return converted_text, bs_pressed
end


-- 入力間違いを無視して、入力文字列を変換して返す
function input_handler_convert_ignore_miss(converted_text, input, expected_text)

   local input_utf8 = Utf8(input)
   local input_size = input_utf8:size()

   -- 文字毎に評価する
   for i = 0, input_size - 1 do
      -- 入力候補に一致しない文字は登録しない
      local ch = input_utf8:substr(i, 1):toStdString()
      local matched_text, miss_detected =
         waka_handler_input_sample(expected_text,
                                   converted_text .. ch)
      if miss_detected then
         break
      end
      converted_text = convertToJp(converted_text .. ch, is_roman_)
   end

   if bs_event_:isActive() then
      local utf8_text = Utf8(converted_text)
      utf8_text:pop_back()
      converted_text = utf8_text:toStdString()
   end

   return converted_text
end