-- オプション
--
-- Satofumi KAMIMURA
-- $Id: option_config.lua,v 4d0ba6dde175 2011/05/15 22:27:49 satofumi $

require("menu_utils")
require("option_save")


-- state: オプション
option_config = {}

local subtitle_font_size = 30
local option_font_size = 26


local option_ = nil

local title_ = nil
local title_label_ = nil

-- !!! 配列にまとめる
local subtitle_input_ = nil
local subtitle_input_label_ = nil
local subtitle_screen_ = nil
local subtitle_screen_label_ = nil
local subtitle_volume_ = nil
local subtitle_volume_label_ = nil
local subtitle_volume_music_ = nil
local subtitle_volume_music_label_ = nil
local subtitle_volume_se_ = nil
local subtitle_volume_se_label_ = nil

local option_input_ = nil
local option_input_buttons_ = nil
local option_input_surfaces_ = nil
local option_input_cursor_ = nil

local option_screen_ = nil
local option_screen_buttons_ = nil
local option_screen_surfaces_ = nil
local option_screen_cursor_ = nil

local volume_music_ = nil
local volume_music_buttons_ = nil
local volume_music_surfaces_ = nil
local volume_music_cursor_ = nil

local volume_se_ = nil
local volume_se_buttons_ = nil
local volume_se_surfaces_ = nil
local volume_se_cursor_ = nil

local back_message_ = nil
local back_message_label_ = nil

local is_roman_index_ = 0
local is_fullscreen_index_ = 0


function load_option_data()
   is_roman_index_ = is_roman_ and 0 or 1
   option_input_:setIndex(is_roman_index_)
   option_input_:press(is_roman_index_ + 1)

   is_fullscreen_index_ = is_fullscreen_ and 0 or 1
   option_screen_:setIndex(is_fullscreen_index_)
   option_screen_:press(is_fullscreen_index_ + 1)

   volume_music_:press(volume_music_index_ + 1)
   volume_se_:press(volume_se_index_ + 1)
end


function update_option_variable()
   if option_input_:clickedIndex() ~= is_roman_index_ then
      is_roman_index_ = option_input_:clickedIndex()
      is_roman_ = is_roman_index_ == 0 and true or false
   end

   if option_screen_:clickedIndex() ~= is_fullscreen_index_ then
      is_fullscreen_index_ = option_screen_:clickedIndex()
      is_fullscreen_ = is_fullscreen_index_ == 0 and true or false

      -- ウィンドウ設定を反映させる
      if screen_:isFullscreen() ~= is_fullscreen_ then
         screen_:toggleScreen()
      end
   end

   -- 曲の音量設定を反映させる
   if volume_music_:clickedIndex() >= 0 and volume_music_:clickedIndex() ~= volume_music_index_ then
      volume_music_index_ = volume_music_:clickedIndex()
      back_music_:setVolume(volume_music_index_ * 10)
   end

   -- 効果音の音量設定を反映させる
   if volume_se_:clickedIndex() >= 0 and volume_se_:clickedIndex() ~= volume_se_index_ then
      volume_se_index_ = volume_se_:clickedIndex()
      sound_effect_input_terminated_:setMasterVolume(volume_se_index_ * 10)
      sound_effect_input_terminated_:play(0.0, 0.0, 0.1)
   end
end


option_config["Enter"] =
   function(state)
      -- オプション操作のコンポーネント
      option_ = Option(screen_:rect())
      layer_:push_front(option_)

      -- タイトルの作成
      font_:setPixelSize(40)
      title_ = TextSurface(font_, "オプション")
      title_label_ = Label(title_)
      title_label_:setPosition(Point(center(title_label_,
                                            screen_:rect().w / 2), 32))
      layer_:push_front(title_label_)

      -- サブタイトル
      local item_x = 70
      local item_y = 90
      local item_height = 100
      font_:setPixelSize(subtitle_font_size)
      subtitle_input_ = TextSurface(font_, "入力方法")
      subtitle_input_label_ = Label(subtitle_input_)
      subtitle_input_label_:setPosition(Point(item_x, item_y))
      layer_:push_front(subtitle_input_label_)
      item_y = item_y + item_height

      subtitle_screen_ = TextSurface(font_, "画面")
      subtitle_screen_label_ = Label(subtitle_screen_)
      subtitle_screen_label_:setPosition(Point(item_x, item_y))
      layer_:push_front(subtitle_screen_label_)
      item_y = item_y + item_height

      if back_music_:isMute() then
         subtitle_volume_ = TextSurface(font_, "音量 (消音中)")
      else
         subtitle_volume_ = TextSurface(font_, "音量")
      end
      subtitle_volume_label_ = Label(subtitle_volume_)
      subtitle_volume_label_:setPosition(Point(item_x, item_y))
      layer_:push_front(subtitle_volume_label_)
      item_y = item_y + item_height * 1.3


      -- ローマ字 / かな
      local option_input_rect = Rect(0, 0, screen_:rect().w, option_font_size)
      option_input_ = Menu(option_input_rect, Menu.Middle, Menu.Horizontal)
      local buttons_text = {
         "ローマ字",
         "かな",
      }
      local base_rect = Rect(0, 0, 160, 35)
      local option_x = 130
      local option_input_y = 135
      option_input_buttons_ = {}
      option_input_surfaces_ = {}

      local cursor_rect = Rect(0, 0, base_rect.w, 4)
      local cursor_surface =
         ColorSurface(cursor_rect, Color(0.0, 0.3, 0.0, 1.0))
      option_input_cursor_ = Label(cursor_surface)
      table.insert(option_input_surfaces_, cursor_surface)

      createMenu(option_input_, buttons_text, base_rect, font_,
                 option_input_surfaces_, option_input_buttons_, "center")

      local buttons_step = Point(190, 0)
      option_input_:setButtonStep(buttons_step)
      option_input_:setEnableClickedAndFocus(true)
      option_:addSubMenu(option_input_, Point(option_x, option_input_y),
                         option_input_cursor_,
                         Point(0, base_rect.h/2 + 4), false)


      -- フルスクリーン / ウィンドウ
      font_:setPixelSize(option_font_size)
      local option_screen_rect = Rect(0, 0, screen_:rect().w, option_font_size)
      option_screen_ = Menu(option_input_rect, Menu.Middle, Menu.Horizontal)
      buttons_text = {
         "フルスクリーン",
         "ウィンドウ",
      }
      base_rect = Rect(0, 0, 200, 35)
      option_x = 130
      local option_screen_y = 235
      option_screen_buttons_ = {}
      option_screen_surfaces_ = {}

      cursor_rect = Rect(0, 0, base_rect.w, 4)
      cursor_surface = ColorSurface(cursor_rect, Color(0.0, 0.3, 0.0, 1.0))
      option_screen_cursor_ = Label(cursor_surface)
      table.insert(option_screen_surfaces_, cursor_surface)

      createMenu(option_screen_, buttons_text, base_rect, font_,
                 option_screen_surfaces_, option_screen_buttons_, "center")

      buttons_step = Point(230, 0)
      option_screen_:setButtonStep(buttons_step)
      option_screen_:setEnableClickedAndFocus(true)
      option_:addSubMenu(option_screen_, Point(option_x, option_screen_y),
                         option_screen_cursor_,
                         Point(0, base_rect.h/2 + 4), false)


      -- 曲
      font_:setPixelSize(subtitle_font_size)
      local music_x = 120
      local music_y = 330
      subtitle_volume_music_ = TextSurface(font_, "曲")
      subtitle_volume_music_label_ = Label(subtitle_volume_music_)
      subtitle_volume_music_label_:setPosition(Point(music_x, music_y))
      layer_:push_front(subtitle_volume_music_label_)

      -- 効果音
      local se_x = 90
      local se_y = 380
      subtitle_volume_se_ = TextSurface(font_, "効果音")
      subtitle_volume_se_label_ = Label(subtitle_volume_se_)
      subtitle_volume_se_label_:setPosition(Point(se_x, se_y))
      layer_:push_front(subtitle_volume_se_label_)

      -- 曲の音量
      font_:setPixelSize(option_font_size - 2)
      local volume_music_rect = Rect(0, 0, screen_:rect().w, option_font_size)
      volume_music_ = Menu(volume_music_rect, Menu.Middle, Menu.Horizontal)
      buttons_text = { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10" }
      base_rect = Rect(0, 0, 25, 35)
      local volume_music_x = 190
      local volume_music_y = music_y
      volume_music_buttons_ = {}
      volume_music_surfaces_ = {}

      cursor_rect = Rect(0, 0, base_rect.w, 4)
      cursor_surface = ColorSurface(cursor_rect, Color(0.0, 0.3, 0.0, 1.0))
      volume_music_cursor_ = Label(cursor_surface)
      table.insert(volume_music_surfaces_, cursor_surface)

      createMenu(volume_music_, buttons_text, base_rect, font_,
                 volume_music_surfaces_, volume_music_buttons_, "center")

      buttons_step = Point(32, 0)
      volume_music_:setButtonStep(buttons_step)
      volume_music_:setEnableClickedAndFocus(true)
      option_:addSubMenu(volume_music_, Point(volume_music_x, volume_music_y),
                         volume_music_cursor_,
                         Point(0, base_rect.h/2 + 4), false)


      -- 効果音の音量
      local volume_se_rect = Rect(0, 0, screen_:rect().w, option_font_size)
      volume_se_ = Menu(volume_se_rect, Menu.Middle, Menu.Horizontal)
      local volume_se_x = 190
      local volume_se_y = se_y
      volume_se_buttons_ = {}
      volume_se_surfaces_ = {}

      cursor_rect = Rect(0, 0, base_rect.w, 4)
      cursor_surface = ColorSurface(cursor_rect, Color(0.0, 0.3, 0.0, 1.0))
      volume_se_cursor_ = Label(cursor_surface)
      table.insert(volume_se_surfaces_, cursor_surface)

      createMenu(volume_se_, buttons_text, base_rect, font_,
                 volume_se_surfaces_, volume_se_buttons_, "center")

      volume_se_:setButtonStep(buttons_step)
      volume_se_:setEnableClickedAndFocus(true)
      option_:addSubMenu(volume_se_, Point(volume_se_x, volume_se_y),
                         volume_se_cursor_, Point(0, base_rect.h/2 + 4), false)


      -- '戻る' メッセージの表示
      font_:setPixelSize(22)
      back_message_ = TextSurface(font_, "ESC で戻ります.")
      back_message_label_ = Label(back_message_)
      local position = Point(right(back_message_label_, screen_:rect().w) - 12,
                             bottom(back_message_label_, screen_:rect().h) - 12)
      back_message_label_:setPosition(position)
      layer_:push_front(back_message_label_)


      -- 保存されている設定を読み出して反映させる
      load_option_data()
   end


option_config["Execute"] =
   function(state)
      update_option_variable()
      redraw()

      -- Enter イベントを読み捨てる
      enter_event_:isActive()

      if escape_event_:isActive() then
         state:stateMachine():changePreviousState()
      end
   end


option_config["Exit"] =
   function(state)
      -- 変更内容の保存
      option_save()

      layer_:remove(option_)

      layer_:remove(title_label_)

      layer_:remove(subtitle_input_label_)
      layer_:remove(subtitle_screen_label_)
      layer_:remove(subtitle_volume_label_)
      layer_:remove(subtitle_volume_music_label_)
      layer_:remove(subtitle_volume_se_label_)
      layer_:remove(back_message_label_)

      layer_:remove(option_input_)
      layer_:remove(option_screen_)
      layer_:remove(volume_music_)
      layer_:remove(volume_se_)

      subtitle_input_label_ = nil
      subtitle_input_ = nil
      subtitle_screen_label_ = nil
      subtitle_screen_ = nil
      subtitle_volume_label_ = nil
      subtitle_volume_ = nil

      subtitle_volume_music_label_ = nil
      subtitle_volume_music_ = nil

      subtitle_volume_se_label_ = nil
      subtitle_volume_se_ = nil

      option_input_cursor_ = nil
      option_input_buttons_ = nil
      option_input_surfaces_ = nil
      option_input_ = nil

      option_screen_cursor_ = nil
      option_screen_buttons_ = nil
      option_screen_surfaces_ = nil
      option_screen_ = nil

      volume_music_cursor_ = nil
      volume_music_buttons_ = nil
      volume_music_surfaces_ = nil
      volume_music_ = nil

      volume_se_cursor_ = nil
      volume_se_buttons_ = nil
      volume_se_surfaces_ = nil
      volume_se_ = nil

      back_message_ = nil
      back_message_label_ = nil

      title_label_ = nil
      title_ = nil

      option_ = nil
   end
