-- タイピング履歴を表示
--
-- Satofumi KAMIMURA
-- $Id$

require("db_local")
require("display_history")


-- state: タイピング履歴を表示
recent_history = {}

local Initialized = 1

local state_ = 0
local title_ = nil
local title_label_ = nil


function recent_history_clear()
   layer_:remove(title_label_);

   title_label_ = nil
   title_ = nil
   state_ = 0
end


recent_history["Enter"] =
   function(state)
      if state_ ~= Initialized then
         -- タイトルの描画
         title_ = TextSurface(font_, "タイピング履歴")
         title_label_ = Label(title_)
         title_label_:setPosition(Point(center(title_label_,
                                               screen_:rect().w / 2), 16))
         layer_:push_front(title_label_);

         -- 表示する履歴の情報を読み出す
         db_local_connect()
         local history_data = db_local_history(20)

         -- グラフの作成
         local rect = Rect(0, 0, screen_:rect().w - 20, screen_:rect().h - 95)
         local position = Point((screen_:rect().w - rect.w) / 2, 56)
         display_history_graph(history_data, rect, position)

         -- ENTER の入力待ちへ
         require("wait_enter")
         state:stateMachine():changeState(wait_enter)
         state_ = Initialized
      end
   end


recent_history["Execute"] =
   function(state)
      redraw()

      if escape_event_:isActive() then
         -- 直後に戻るので、何もしない
      end

      state:stateMachine():changePreviousState()
      recent_history_clear()
      display_history_graph_remove()
   end


recent_history["Exit"] =
   function(state)
   end
