-- メッセージの表示
--
-- Satofumi KAMIMURA
-- $Id$

require("wait_enter")


-- state: メッセージ表示
show_message = {}


local show_message_ = {}
local position_ = nil
local no_cursor_ = nil

local message_ = {}
local message_label_ = {}
local scheduler_id_ = nil


-- メッセージを表示し、Enter キーを振動させる
function show_message_display()
   -- メッセージの表示
   for i = 1, #message_label_ do
      layer_:push_front(message_label_[i])
   end
   local last_position = message_label_[#message_label_]:position()

   -- Enter 画像を振動させる
   last_position.x = last_position.x + message_label_[#message_label_]:rect().w
   last_position.y = last_position.y + 3
   layer_:push_front(enter_label_)
   wait_enter_vibrate_enter(last_position)
end



function show_message_enter()
   local y = 0
   for i = 1, #show_message_ do
      message_[i] = TextSurface(font_, show_message_[i])
      message_label_[i] = Label(message_[i])
      local position = Point(position_.x, position_.y + y)
      position.x = position_.x - message_label_[i]:rect().w / 2
      message_label_[i]:setPosition(position)
      y = y + message_label_[i]:rect().h
   end

   scheduler_id_ = scheduler_:insert(show_message_display)
end


function show_message_execute()
   while true do
      scheduler_:execute()
      redraw()

      if escape_event_:isActive() then
         -- 呼び出し元での ESCAPE キーの処理が実行されるようにする
         escape_event_:setActive()
         return
      end

      if enter_event_:isActive() then
         return
      end
   end
end


function show_message_exit()
   layer_:remove(enter_label_)
   for i = 1, #message_label_ do
      layer_:remove(message_label_[i])
      message_label_[i] = nil
      message_[i] = nil
   end
   message_label_ = {}
   message_ = {}

   scheduler_:remove(scheduler_id_)
   scheduler_id_ = nil
end


-- メッセージの表示
function show_message(message, position, no_cursor)
   show_message_ = message
   if position == nil then
      position_ = Point(screen_:rect().w / 2, screen_:rect().h / 2)
   else
      -- そのままコピーすると浅いコピーになるため、オブジェクトを作りなおす
      position_ = Point(position.x, position.y)
   end
   if no_cursor == nil then
      no_cursor_ = false
   else
      no_cursor_ = no_cursor
   end

   -- Enter
   show_message_enter()
   if no_cursor_ then
      return
   end

   -- Execute
   show_message_execute()

   -- Exit
   show_message_exit()
end


-- メッセージの削除
function show_message_remove()
   show_message_exit()
end