-- 改行か左クリックを待つ
--
-- Satofumi KAMIMURA
-- $Id: wait_enter.lua,v 395223f99671 2010/05/23 16:13:24 Satofumi $

-- \todo enter.png も表示し、微妙に振動させる


-- state: 改行待ち
wait_enter = {}


local message_ = nil
local message_label_ = nil
local scheduler_blink_id_ = nil


-- Enter 画像を振動させる
function wait_enter_vibrate_enter(position)
   while true do
      enter_label_:setPosition(Point(position.x + 0, position.y - 0))
      Scheduler:wait(500)

      enter_label_:setPosition(Point(position.x + 0, position.y - 3))
      Scheduler:wait(100)

      enter_label_:setPosition(Point(position.x + 0, position.y - 0))
      Scheduler:wait(100)

      enter_label_:setPosition(Point(position.x + 0, position.y - 3))
      Scheduler:wait(100)
   end
end


-- 決められた時間が経過したら "hit enter key" を画面の左下に表示する
function wait_enter_display_message()
   Scheduler:wait(3000)
   layer_:push_front(message_label_)

   -- Enter 画像を振動させる
   local position = Point(right(enter_label_, screen_:rect().w) - 12,
                          bottom(enter_label_, screen_:rect().h) - 12)
   layer_:push_front(enter_label_)
   wait_enter_vibrate_enter(position)
end


wait_enter["Enter"] =
   function(state)
      -- メッセージの作成
      font_:setPixelSize(26)
      message_ = TextSurface(font_, "hit enter key")
      message_label_ = Label(message_)
      local position = Point(right(message_label_, screen_:rect().w) - 32,
                             bottom(message_label_, screen_:rect().h) - 12)
      message_label_:setPosition(position)

      scheduler_blink_id_ = scheduler_:insert(wait_enter_display_message)

      -- 改行についての状態をクリア
      enter_event_:isActive()
   end


wait_enter["Execute"] =
   function(state)
      scheduler_:execute()
      redraw()

      if escape_event_:isActive() then
         -- 呼び出し元での ESCAPE キーの処理が実行されるようにする
         escape_event_:setActive()
         state:stateMachine():changePreviousState()
         return
      end

      if enter_event_:isActive() then
         state:stateMachine():changePreviousState()
      end
   end


wait_enter["Exit"] =
   function(state)
      layer_:remove(enter_label_)
      layer_:remove(message_label_)
      message_label_ = nil
      message_ = nil

      scheduler_:remove(scheduler_blink_id_)
      scheduler_blink_id_ = nil
   end
